/*

jednicka v levo urcuje pocet mist, vysouva se doprava, lsb first
*/
module decoder(
    input [8:0] data_in,
    output reg [3:0] n,
    output reg [7:0] data8
    );
		
always @(data_in)
begin
	if(data_in[8]==1)
	begin
		data8=data_in[7:0];
		n=8;
	end
	else if({data_in[8:7]}==1)
	begin
		data8={data_in[6:0]};
		n=7;
	end
	else if(data_in[8:6]==1)
	begin
		data8=data_in[5:0];
		n=6;
	end
	else if(data_in[8:5]==1)
	begin
		data8=data_in[4:0];
		n=5;
	end
	else if(data_in[8:4]==1)
	begin
		data8=data_in[3:0];
		n=4;
	end
	else if(data_in[8:3]==1)
	begin
		data8=data_in[2:0];
		n=3;
	end
	else if(data_in[8:2]==1)
	begin
		data8=data_in[1:0];
		n=2;
	end
	else if(data_in[8:1]==1)
	begin
		data8=data_in[0];
		n=1;
	end
	else
	begin
		data8=0;
		n=0;
	end
	
end

endmodule
