`timescale 1ns / 100ps
module fsm_test ;//(out, data_valid);

   reg rf_in;
   reg reset;
   reg clk;   
   wire [8:0] out;
	wire [8:0] out_tmp;
	wire [4:0] count;
	wire clk_8;
	
	wire [1:0] idle;
	wire x2rf_in, last_bit;
	reg txrx;

   reg eof;
   reg stop;
	 
	 reg [8:0] dataout;
   reg ld;
	 reg startup;
	 
   integer test_count;
   integer chars; 
   integer in;
	
	
	integer testn;
   top top(.rf_in(rf_in), .reset(reset),.clk(clk),.data(out),.data_valid(data_valid),.eot(eot), .txrx(txrx), .ld(ld), .tx_out(tx_out)/*, .idle(idle), .x2rf_in(x2rf_in), .last_bit(last_bit)*/);
  
	assign out=dataout;
	
	initial
   begin: init
			startup<=1;	
      in  = $fopen("input6.txt","r");
      rf_in=0;
      reset<= 1'b0;
      #(100);
      reset <= 1'b1;
      #(300);
      reset <= 1'b0;
      stop<=1'b0;
      chars=0;
			testn=0;
			txrx=1;
			dataout='bz;
			ld<=0;
			test_count<=500;
			
		
   end
  
   always
   begin: clock
      clk <= 1'b0;
    #(50);
		//#(73.746);
      clk <= 1'b1;
    #(50);
		//#(73.746);
   end 
   
   always @(posedge clk or reset)
   begin: test
      if(reset == 1'b1) begin
         //test_count = 0;
      end
		else if(testn==0)begin
			if(stop==1'b0) begin
			//else begin
				if(startup)begin
					if (test_count <= 0)startup <= 0;	
					else test_count= test_count - 1;
					if(test_count==480)txrx<=0;
					if(test_count==450)rf_in<=1;
				end
				
				else if(rf_in==1'b1) begin
				 if (test_count <= 0)begin
					rf_in <= 1'b0;
					//test_count=16;
					test_count=15;
				 end
				 else test_count= test_count - 1;
			  end
			  else begin
				 if (test_count <= 0)begin
					rf_in <= 1'b1;
	//            eof=$feof(in);
					test_count=$fgetc(in);
					if(test_count==255 || chars==50)begin
						testn=testn+1;
						in  = $fopen("input5.txt","r");
						rf_in=1'b1;
						stop<=1'b0;
						chars=0;
						#(30000);
						//txrx<=1;
						#(300);
						//txrx<=0;
						#(30000);
					end 
					else begin
						chars=chars+1;
						test_count=test_count*8-1;
					end
				 end
				 else test_count= test_count - 1;
			  end
			end
		end
		else if(testn==1) begin
			/*//#(221)
			#(50000)
			txrx<=1;
			dataout=9'b1_0000_0000;
			#(10000)
			ld<=1;
			#(100)
			ld<=0;
			//#(7500);
			#(85000);
			dataout=9'b1_1111_1111;
			#(10000)
			ld<=1;
			ld<=1;
			#(250)
			ld<=0;
			//#(7500);
			#(500000);*/
			//#(10000);
			if(stop==1'b0) begin
			//else begin
			  if(rf_in==1'b1) begin
				 if (test_count <= 0)begin
					rf_in <= 1'b0;
					//test_count=16;
					test_count=15;
				 end
				 else test_count= test_count - 1;
			  end
			  else begin
				 if (test_count <= 0)begin
					rf_in <= 1'b1;
//            eof=$feof(in);
					test_count=$fgetc(in);
					if(test_count==255 || chars==50)begin
					  //$write("ERROR: ");
						//$display("high failed");
						//$stop;
						stop<=1'b1;
						
					end 
					else begin
						chars=chars+1;
						test_count=test_count*8-1;
					end
				 end
				 else test_count= test_count - 1;
			  end
			end
		end
    end
endmodule
