module shifter(
		input clk,
		input txrx,
    input ld,
    input [7:0] data,
    input [3:0] n,
    output reg tx_bit,
    input shift_pulse,
		output reg tx_finished,
		output reg loaded_d1,
		output reg [7:0] d,
		output reg [7:0] d1,
		output reg [3:0] dn,
		output reg [3:0] dn1,
		output reg ld_old
    );

//reg [7:0] d;
//reg [7:0] d1;
//reg [3:0] dn;
//reg [3:0] dn1;

//reg loaded_d1;
//reg loaded_d2;

always @(posedge ld)
begin
	d1<=data;
	dn1<=n;
end


always @(posedge clk )
begin
	if(!txrx)
	begin
		tx_finished<=1;
		tx_bit<=0;
		loaded_d1<=0;
		dn<=0;
	end
	else
	begin
		if(ld && !ld_old)
		begin
			loaded_d1<=1;
		end
	  else if(loaded_d1==1 && tx_finished==1)
		begin
			loaded_d1<=0;
			d<=d1;
			dn<=dn1;
			tx_bit<=0;
		end
		else if(shift_pulse==1)
		begin
			if(dn==0 /*&& tx_finished==0*/)
			begin
				if(loaded_d1==1)
				begin
					/*d<=d1;
					dn<=dn1;
					tx_bit<={d[0]};
					d<={1'b0,d[7:1]};
					dn<=dn-1;	*/
					d<={1'b0,d1[7:1]};
					dn<=dn1-1;					
					tx_finished<=0;
					loaded_d1<=0;
				end
				else tx_finished<=1;
			end
			else
			begin
				if(tx_finished==1)tx_finished<=0;
				tx_bit<={d[0]};
				d<={1'b0,d[7:1]};
				dn<=dn-1;
			end
		end	
		ld_old<=ld;
	end
end

endmodule

/*

always @(posedge clk )
begin
	if(!txrx)
	begin
		tx_finished<=1;
		tx_bit<=0;
		loaded_d1<=0;
	end
	else
	begin
		if(ld && !ld_old)
		begin
			loaded_d1<=1;
		end
	  else if(loaded_d1==1 && tx_finished==1)
		begin
			loaded_d1<=0;
			d<=d1;
			dn<=dn1;
			tx_bit<=0;
		end
		else if(shift_pulse==1)
		begin
			if(dn==0 )///&& tx_finished==0)
			begin
				if(loaded_d1==1)
				begin
					d<=d1;
					dn<=dn1;
					tx_bit<={d[0]};
					d<={1'b0,d[7:1]};
					dn<=dn-1;	
					tx_finished<=0;
					loaded_d1<=0;
				end
				else tx_finished<=1;
			end
			else
			begin
				if(tx_finished==1)tx_finished<=0;
				tx_bit<={d[0]};
				d<={1'b0,d[7:1]};
				dn<=dn-1;
			end
		end	
		ld_old<=ld;
	end
end

endmodule
*/

/*always @(posedge ld)
begin
	loaded<=1;
	d1<=data;
	dn1<=n;
end


always @(posedge shift_pulse or posedge loaded)
begin


	if(loaded==1 && tx_finished==1)
	begin
		tx_finished<=0;
		d<=d1;
		dn<=dn1;
		tx_bit<=0;
	end
	
	else if(shift_pulse==1)
	begin
		tx_bit<=d[0];
		d<={1'b0,d[7:1]};
		dn<=dn-1;		
		if(dn==0)
		begin
			if(loaded==1)
			begin
				d<=d1;
				dn<=dn1;
				tx_finished<=0;
				loaded<=0;
			end
			else tx_finished<=1;
		end
	end	
end

endmodule
*/
