module tx_logic(clk8r,clk64,tx_finished, tx_in, tx_out, tx_loaded);

input clk8r; 
input clk64;
input tx_finished;
input tx_in;
input tx_loaded;
output reg tx_out;

//reg tx_d;
//reg tx_act_d;
reg anda;
reg xora;

always @(tx_finished, tx_loaded, clk64)
begin:andaa
  anda=!tx_finished & tx_loaded & clk64;
end

always @(clk8r, tx_in)
begin:xoraa
  xora=clk8r ^ tx_in;
end

always @(anda, xora)
begin:andbb
  tx_out=anda & xora;
end
endmodule


