
module tx_top(
	input clk,
	input reset_count,
	input last_bit,
  input txrx,
	input ld,
	input [8:0] data_in,
	output tx_out,
	/*output clk64r,
	output clk8r,*/
	output tx_finished,
	/*output tx_loaded,
	output tx_bit,
	output loaded_d1,
	output [7:0] d,
	output [7:0] d1,
	output [3:0] dn,
	output [3:0] dn1,
	output [3:0] n,
	output [7:0] data8,*/
	output tx_p
	/*output ld_old*/
	);
/*
	input clk;
	input reset;
	input eot;
	input reset_count;
	input last_bit;
	output start_tx2;
*/	
	
	wire clk8r, clk64r;
	//wire start_tx;
	//reg tx_in, tx_act;
	
	wire [3:0] n;
	wire [7:0] data8;
	
	wire [7:0] d;
	wire [7:0] d1;
	wire [3:0] dn;
	wire [3:0] dn1;
	//wire shift_en;
	//wire tx_p;
	
	wire tx_loaded;
	//wire tx_finished;
	
	
	
	
	
	
	
	shifter shifter(.clk(clk),  .txrx(txrx), .ld(ld), .data(data8),.n(n),.tx_bit(tx_bit),.shift_pulse(tx_p),
	.tx_finished(tx_finished), .loaded_d1(loaded_d1),
	.d(d), .d1(d1), .dn(dn), .dn1(dn1), .ld_old(ld_old)
	);
	timer timer(.clk(clk), .reset_count(reset_count),.last_bit(last_bit),.clk8(clk8r),.clk64(clk64r),.tx_pulse(tx_p), .tx_loaded(tx_loaded));
	waiter waiter(.clk(clk), .txrx(txrx), .ld(ld), .tx_loaded(tx_loaded), .tx_finished(tx_finished));
	
	decoder decoder(.data_in(data_in),.n(n),.data8(data8));
	tx_logic txlogic(.clk8r(clk8r), .clk64(clk64r),.tx_finished(tx_finished), .tx_in(tx_bit), .tx_out(tx_out), .tx_loaded(tx_loaded));
  
	
	
	/*initial
	begin
		tx_in<=1;
		tx_act<=1;
	end*/

endmodule
