
module waiter(input txrx,input ld,input clk, output reg tx_loaded, input tx_finished);

reg tx_finished_old;

always @( posedge clk)
begin
	if(!txrx)
	begin
		tx_loaded<=0;
	end
	else
	begin
		if(ld==1)tx_loaded<=1;
		else if(tx_finished && !tx_finished_old)tx_loaded<=0;
		tx_finished_old<=tx_finished;
	end
end

endmodule

